/*************************************************
* Default Allocator Source File                  *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/defalloc.h>
#include <cstdlib>
#include <cstring>

namespace OpenCL {

/*************************************************
* Allocation                                     *
*************************************************/
void* Default_Allocator::alloc_block(u32bit n) const
   {
   void* ptr = std::malloc(n);
   std::memset(ptr, 0, n);
   return ptr;
   }

/*************************************************
* Deallocation                                   *
*************************************************/
void Default_Allocator::dealloc_block(void* ptr, u32bit n) const
   {
   std::memset(ptr, 0, n);
   std::free(ptr);
   }

}
